using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace AncientWeapons
{
    public class AncientWeapons
    {
        public static void Main()
        {
			//WARNING. If you want to create your weapon mod you can use this mod as example. Good luck!
            //Gladius
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Gladius",
                    NameToOrderByOverride = "Gladius",
                    DescriptionOverride = "An ancient melee weapon",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Gladiusthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Gladius.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Pilum
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Spear"),
                    NameOverride = "Pilum",
                    NameToOrderByOverride = "Pilum",
                    DescriptionOverride = "An ancient Roman weapon",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("pilumthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pilum.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Roman Shield
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Roman Tower Shield",
                    NameToOrderByOverride = "Roman Shield",
                    DescriptionOverride = "An ancient Roman shield",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("towershieldthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("towershield.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Greek Shield
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Hoplite Shield",
                    NameToOrderByOverride = "Hoplite Shield",
                    DescriptionOverride = "An ancient Greek shield",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Hopliteshieldthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hopliteshield.png", 1f);
						Instance.FixColliders();
                    }
                }
            );

            //Long-Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Long-Sword",
                    NameToOrderByOverride = "Longsword",
                    DescriptionOverride = "A reliable long sword",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Longswordthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Longsword.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Zweihander
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Zweihänder",
                    NameToOrderByOverride = "Zweihander",
                    DescriptionOverride = "A reliable zweihander",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Zweihanderthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Zweihander.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Rapier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Rapier",
                    NameToOrderByOverride = "Rapier",
                    DescriptionOverride = "A reliable broad-bladed rapier",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("rapierthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("rapier.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Sabre
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Sabre",
                    NameToOrderByOverride = "Sabre",
                    DescriptionOverride = "A cavalry sabre",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("sabrethumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sabre.png", 1f);
						Instance.FixColliders();
                    }
                }
            );
			
            //Flintlock Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Revolver"),
                    NameOverride = "Flintlock Pistol",
                    NameToOrderByOverride = "Flintlock",
                    DescriptionOverride = "a flintlock pistol",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("flintlockthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Musket.wav"),
							ModAPI.LoadSound("Musket2.wav"),
						};
						Instance.AddComponent<UseEventTrigger>().Action = () => {
						ModAPI.CreateParticleEffect("Flash", Instance.transform.position);
						};
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("flintlock.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );

            //Musket
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Musket",
                    NameToOrderByOverride = "Musket",
                    DescriptionOverride = "a musket",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("Musketthumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("Musket.wav"),
							ModAPI.LoadSound("Musket2.wav"),
						};
						Instance.AddComponent<UseEventTrigger>().Action = () => {
						ModAPI.CreateParticleEffect("Flash", Instance.transform.position);
						};
						Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("musket.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
        }
    }
}